function recreateDSTree(serviceName) {
    var dsTree = Dom.get('dsTree');
    var dsTreeElements = dsTree.childNodes;
    var lastQueryNode = "";
    for(var i = 0;i<dsTreeElements.length;i++){
        dsTree.removeChild(dsTreeElements[i]);
    }
    createNewDSHTML(serviceName);

    //set the service name
    Dom.get("rootNode").innerHTML = serviceName;

    //Create the child config nodes
    var itemNodes = doc.getElementsByTagName("config");
    var configs = new Array();
    for (i = 0; i <  itemNodes.length; i++) {
        selected = Dom.get("main_con");
        if(itemNodes[i].getAttribute("id") == null){
            var itemId = "default";
            itemNodes[i].setAttribute("id",itemId);
        }else{
            itemId =  itemNodes[i].getAttribute("id");
        }

        tmpSelected = null; //ignore the tempary cration on new node creation
        var returned = addNewNodeToTree(itemId, itemId, "con");
        configs.push(returned);
    }

    for(var k=0;k<configs.length;k++){
        var configNode = configs[k];
        createQueryNodesForConfig(configNode);
    }

    itemNodes = doc.getElementsByTagName(const_operation_root);

    for (i = 0; i <  itemNodes.length; i++) {
        selected = Dom.get("main_ops");
        itemId =  itemNodes[i].getAttribute("name");
        tmpSelected = null;
        addNewNodeToTree(itemId, itemId, "ops");
    }

    itemNodes = doc.getElementsByTagName(const_resource_root);

    for (i = 0; i <  itemNodes.length; i++) {
        selected = Dom.get("main_res");
        itemId =  itemNodes[i].getAttribute(const_resource_path);
        tmpSelected = null;
        addNewNodeToTree(itemId, itemId, "res");
    }

    itemNodes = doc.getElementsByTagName(const_event_root);

    for (i = 0; i <  itemNodes.length; i++) {
        selected = Dom.get("main_eve");
        itemId =  itemNodes[i].getAttribute("id");
        tmpSelected = null;
        addNewNodeToTree(itemId, itemId, "eve");
    }
    mode = "edit";
    $(document).ready(function() {    
        makeAllQueriesDraggable();       
    });
    selectNode(Dom.get("rootNode"));

    Event.onDOMReady(function(){
        cleanSelected();
         if (!Dom.hasClass("rootNode", "selected")) {
            Dom.addClass("rootNode", "selected");
        }
    })

}
function createQueryNodesForConfig(configNode) {
    Event.onAvailable(configNode, function() {
        var queryNodes = doc.getElementsByTagName(const_query_root);
        for (var j = 0; j < queryNodes.length; j++) {
            if (queryNodes[j].getAttribute(const_query_config) == null) {
                var useConfig = "default";
                queryNodes[j].setAttribute(const_query_config, useConfig);
            } else {
                useConfig = queryNodes[j].getAttribute(const_query_config);
            }
            if (configNode == ("con_" + useConfig)) {
                selected = Dom.get(configNode);
                var queryId = queryNodes[j].getAttribute("id");
                tmpSelected = null;   //ignore the tempary cration on new node creation

                var newQueryId = addNewNodeToTree(queryId, queryId, "coq");
                selected = Dom.get(newQueryId);//slecte the newly created query main node so that the other node get inser inside it as childs
                var configType = getConfigType(useConfig);
                if (configType == rdbms) {
                    addNewNodeToTree("Request", queryId, "crq");
                }
                addNewNodeToTree("Response", queryId, "crs");
            }
            lastQueryNode = queryNodes[queryNodes.length - 1];

        }
    });
}
function makeAllQueriesDraggable(){
    var allQueries = YAHOO.util.Dom.getElementsByClassName('moveNode', 'a');
    for(var i=0;i<allQueries.length;i++){
        $("#"+allQueries[i].id).draggable({ revert: 'valid' });
    }
}

function updateXmlEditorContent() {
    var codeFiltered = editAreaLoader.getValue("xmlEditor");
    doc = str2xml(codeFiltered);
    var dataNode = doc.getElementsByTagName("data")[0];
    recreateDSTree(dataNode.getAttribute("name"));
}
function resetXmlEditorContent(){
    content = format_xml(xmlToString(prevDoc));
    editAreaLoader.setValue("xmlEditor", content);
}
var prevDoc = null;
function doCodeToggle(option){
    var codeContent = Dom.get("codeContent");
    var codeLink = Dom.get("codeLink");
    var designContent = Dom.get("designContent");
    var designLink = Dom.get("designLink");
    var codeButtonRow = Dom.get("codeButtonRow");
    if(option == "code"){
        codeContent.style.display ="";
        var content = "";
        if(doc != null) {
            content = xmlToString(doc);
            content = format_xml(content);
        }   prevDoc = doc;
        if (codeView == null){
            editAreaLoader.init({
                id : "xmlEditor"		// textarea id
                ,syntax: "xml"			// syntax to be uses for highgliting
                ,start_highlight: true		// to display with highlight mode on start-up
                ,allow_resize: "both"
                ,min_height:320
            });
            codeView = 1;
        }
        editAreaLoader.show("xmlEditor");
        if(content.search(/<?xml/) == -1){
            content = '<?xml version="1.0" encoding="UTF-8"?>\n' + content;
        }
        editAreaLoader.setValue("xmlEditor", content);
        codeLink.style.display ="none";

        //Set the page element visibility
        codeButtonRow.style.display = "";
        designContent.style.display = "none";
        designLink.style.display = "";
        onDesign = false;
    }else if(option == "design"){
        if(codeView!=null){
            var codeFiltered = editAreaLoader.getValue("xmlEditor");
            ///codeFiltered = codeFiltered.replace(/[\n\r]/g,"");
            doc = str2xml(codeFiltered);
            var dataNode = doc.getElementsByTagName("data")[0];
            recreateDSTree(dataNode.getAttribute("name"));
            editAreaLoader.hide("xmlEditor");
        }
        //hide the code area (we don't hide the hole area since it gives an error on EditArea plugin
        codeButtonRow.style.display = "none";

        //Set the page elements visiblility
        codeLink.style.display ="";
        designContent.style.display = "";
        designLink.style.display = "none";
        onDesign = true;
        mode = "edit";
    }
}